diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
index f19a55cdd..b6a248ca2 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
@@ -6,10 +6,11 @@ import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.EmptyChunk;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -18,14 +19,14 @@ import java.io.IOException;
 import java.util.Arrays;
 
 public class ChunkProviderStatic
-    implements IChunkProvider {
+    implements ChunkProvider {
     public static final int CHUNK_RADIUS = 32; // Radius should *always* be a power of 2!
     public static final int CHUNK_MASK = CHUNK_RADIUS * 2 - 1;
 
     private static final Logger LOGGER = LogUtils.getLogger();
     private final Chunk blankChunk;
     public ChunkGenerator chunkGenerator;
-    private final IChunkLoader chunkLoader;
+    private final ChunkLoader chunkLoader;
     private final Chunk[] chunks;
     private final World worldObj;
     int lastQueriedChunkXPos;
@@ -35,7 +36,7 @@ public class ChunkProviderStatic
     private int curChunkY;
 
 
-    public ChunkProviderStatic(World world, IChunkLoader ichunkloader, ChunkGenerator chunkGenerator) {
+    public ChunkProviderStatic(World world, ChunkLoader ichunkloader, ChunkGenerator chunkGenerator) {
         this.chunks = new Chunk[CHUNK_RADIUS * 2 * CHUNK_RADIUS * 2];
         this.lastQueriedChunkXPos = Integer.MIN_VALUE;
         this.lastQueriedChunkZPos = Integer.MIN_VALUE;
@@ -47,75 +48,93 @@ public class ChunkProviderStatic
     }
 
     @Override
-    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
-        this.curChunkX = chunkPos.x;
-        this.curChunkY = chunkPos.z;
+    public void setCurrentChunkOver(@NotNull ChunkPosc chunkPos) {
+        this.curChunkX = chunkPos.x();
+        this.curChunkY = chunkPos.z();
     }
 
-    public boolean canChunkExist(@NotNull ChunkPos chunkPos) {
+    public boolean canChunkExist(@NotNull ChunkPosc chunkPos) {
         byte byte0 = CHUNK_RADIUS - 1;
-        return chunkPos.x >= this.curChunkX - byte0 && chunkPos.z >= this.curChunkY - byte0 && chunkPos.x <= this.curChunkX + byte0 && chunkPos.z <= this.curChunkY + byte0;
+        return chunkPos.x() >= this.curChunkX - byte0 && chunkPos.z() >= this.curChunkY - byte0 && chunkPos.x() <= this.curChunkX + byte0 && chunkPos.z() <= this.curChunkY + byte0;
     }
 
     @Override
-    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
-        int k = chunkPos.x & CHUNK_MASK;
-        int l = chunkPos.z & CHUNK_MASK;
+    public void regenerateChunk(@NotNull ChunkPosc chunkPos) {
+        int k = chunkPos.x() & CHUNK_MASK;
+        int l = chunkPos.z() & CHUNK_MASK;
         int i1 = k + l * CHUNK_RADIUS * 2;
         Chunk newChunk;
         if (this.chunkGenerator != null) {
-            newChunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+            newChunk = this.chunkGenerator.generate(chunkPos.x(), chunkPos.z());
             newChunk.fixMissingBlocks();
         } else {
             return;
         }
         this.chunks[i1] = newChunk;
-        if (!this.chunks[i1].isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-            populate(this, chunkPos.x, chunkPos.z);
+        final @NotNull ChunkPos queryPos = new ChunkPos(chunkPos);
+        if (
+            !newChunk.isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(1, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(0, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(1, 0, queryPos))
+        ) {
+            populate(chunkPos);
         }
-        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-            populate(this, chunkPos.x - 1, chunkPos.z);
+        if (
+            isChunkLoaded(chunkPos.add(-1, 0, queryPos)) && !provideChunk(chunkPos.add(-1, 0, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(-1, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(0, 1, queryPos))
+        ) {
+            populate(chunkPos.add(-1, 0, queryPos));
         }
-        if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-            populate(this, chunkPos.x, chunkPos.z - 1);
+        if (
+            isChunkLoaded(chunkPos.add(0, -1, queryPos)) && !provideChunk(chunkPos.add(0, -1, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(1, -1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(1, 0, queryPos))
+        ) {
+            populate(chunkPos.add(0, -1, queryPos));
         }
-        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-            populate(this, chunkPos.x - 1, chunkPos.z - 1);
+        if (
+            isChunkLoaded(chunkPos.add(-1, -1, queryPos)) && !provideChunk(chunkPos.add(-1, -1, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(0, -1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(-1, 0, queryPos))
+        ) {
+            populate(chunkPos.add(-1, -1, queryPos));
         }
     }
 
     @Override
-    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+    public boolean isChunkLoaded(@NotNull ChunkPosc chunkPos) {
         if (!canChunkExist(chunkPos)) {
             return false;
         }
-        if (chunkPos.x == this.lastQueriedChunkXPos && chunkPos.z == this.lastQueriedChunkZPos && this.lastQueriedChunk != null) {
+        if (chunkPos.x() == this.lastQueriedChunkXPos && chunkPos.z() == this.lastQueriedChunkZPos && this.lastQueriedChunk != null) {
             return true;
         } else {
-            int k = chunkPos.x & CHUNK_MASK;
-            int l = chunkPos.z & CHUNK_MASK;
+            int k = chunkPos.x() & CHUNK_MASK;
+            int l = chunkPos.z() & CHUNK_MASK;
             int chunkIndex = k + l * CHUNK_RADIUS * 2;
-            return this.chunks[chunkIndex] == this.blankChunk || (this.chunks[chunkIndex] != null && this.chunks[chunkIndex].isAtLocation(chunkPos.x, chunkPos.z));
+            return this.chunks[chunkIndex] == this.blankChunk || (this.chunks[chunkIndex] != null && this.chunks[chunkIndex].isAtLocation(chunkPos));
         }
     }
 
     @Override
-    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
-        return provideChunk(chunkPos.x, chunkPos.z);
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
+        return provideChunk(chunkPos, priority);
     }
 
     @Override
-    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
-        if (chunkPos.x == this.lastQueriedChunkXPos && chunkPos.z == this.lastQueriedChunkZPos && this.lastQueriedChunk != null) {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
+        if (chunkPos.x() == this.lastQueriedChunkXPos && chunkPos.z() == this.lastQueriedChunkZPos && this.lastQueriedChunk != null) {
             return this.lastQueriedChunk;
         }
         if (!this.worldObj.findingSpawnPoint && !canChunkExist(chunkPos)) {
             return this.blankChunk;
         }
-        int k = chunkPos.x & CHUNK_MASK;
-        int l = chunkPos.z & CHUNK_MASK;
+        int k = chunkPos.x() & CHUNK_MASK;
+        int l = chunkPos.z() & CHUNK_MASK;
         int i1 = k + l * CHUNK_RADIUS * 2;
-        if (!isChunkLoaded(chunkPos.x, chunkPos.z)) {
+        if (!isChunkLoaded(chunkPos)) {
             if (this.chunks[i1] != null) {
                 saveChunk(this.chunks[i1]);
                 this.chunks[i1].onUnload();
@@ -123,7 +142,7 @@ public class ChunkProviderStatic
             Chunk chunk = loadChunk(chunkPos);
             if (chunk == null) {
                 if (this.chunkGenerator != null) {
-                    chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+                    chunk = this.chunkGenerator.generate(chunkPos.x(), chunkPos.z());
                     chunk.fixMissingBlocks();
                 } else {
                     chunk = this.blankChunk;
@@ -134,40 +153,58 @@ public class ChunkProviderStatic
                 this.chunks[i1].checkForLightGaps();
                 this.chunks[i1].onLoad();
             }
-            if (!this.chunks[i1].isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-                populate(this, chunkPos.x, chunkPos.z);
+            final @NotNull ChunkPos queryPos = new ChunkPos(chunkPos);
+            if (
+                !chunk.isTerrainPopulated &&
+                    isChunkLoaded(chunkPos.add(1, 1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(0, 1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(1, 0, queryPos))
+            ) {
+                populate(chunkPos);
             }
-            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-                populate(this, chunkPos.x - 1, chunkPos.z);
+            if (
+                isChunkLoaded(chunkPos.add(-1, 0, queryPos)) && !provideChunk(chunkPos.add(-1, 0, queryPos), true).isTerrainPopulated &&
+                    isChunkLoaded(chunkPos.add(-1, 1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(0, 1, queryPos))
+            ) {
+                populate(chunkPos.add(-1, 0, queryPos));
             }
-            if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-                populate(this, chunkPos.x, chunkPos.z - 1);
+            if (
+                isChunkLoaded(chunkPos.add(0, -1, queryPos)) && !provideChunk(chunkPos.add(0, -1, queryPos), true).isTerrainPopulated &&
+                    isChunkLoaded(chunkPos.add(1, -1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(1, 0, queryPos))
+            ) {
+                populate(chunkPos.add(0, -1, queryPos));
             }
-            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-                populate(this, chunkPos.x - 1, chunkPos.z - 1);
+            if (
+                isChunkLoaded(chunkPos.add(-1, -1, queryPos)) && !provideChunk(chunkPos.add(-1, -1, queryPos), true).isTerrainPopulated &&
+                    isChunkLoaded(chunkPos.add(0, -1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(-1, 0, queryPos))
+            ) {
+                populate(chunkPos.add(-1, -1, queryPos));
             }
             if (this.worldObj.getCurrentWeather() != null) {
                 this.worldObj.getCurrentWeather().doChunkLoadEffect(this.worldObj, chunk);
             }
         }
-        this.lastQueriedChunkXPos = chunkPos.x;
-        this.lastQueriedChunkZPos = chunkPos.z;
+        this.lastQueriedChunkXPos = chunkPos.x();
+        this.lastQueriedChunkZPos = chunkPos.z();
         this.lastQueriedChunk = this.chunks[i1];
         return this.chunks[i1];
     }
 
-    private Chunk loadChunk(@NotNull ChunkPos chunkPos) {
+    private Chunk loadChunk(@NotNull ChunkPosc chunkPos) {
         if (this.chunkLoader == null) {
             return this.blankChunk;
         }
         try {
-            Chunk chunk = this.chunkLoader.loadChunk(this.worldObj, chunkPos.x, chunkPos.z);
+            Chunk chunk = this.chunkLoader.loadChunk(this.worldObj, chunkPos.x(), chunkPos.z());
             if (chunk != null) {
                 chunk.lastSaveTime = this.worldObj.getWorldTime();
             }
             return chunk;
         } catch (Exception exception) {
-            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkPos.x, chunkPos.z, exception);
+            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkPos.x(), chunkPos.z(), exception);
         }
         return this.blankChunk;
     }
@@ -185,7 +222,7 @@ public class ChunkProviderStatic
     }
 
     @Override
-    public void populate(@NotNull ChunkPos chunkPos) {
+    public void populate(@NotNull ChunkPosc chunkPos) {
         Chunk chunk = provideChunk(chunkPos, true);
         if (!chunk.isTerrainPopulated) {
             chunk.isTerrainPopulated = true;
@@ -254,7 +291,7 @@ public class ChunkProviderStatic
         return "ChunkCache: " + this.chunks.length;
     }
 
-    public IChunkLoader getChunkLoader() {
+    public ChunkLoader getChunkLoader() {
         return this.chunkLoader;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderThreadedClient.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderThreadedClient.java
index a3466059c..ecc925aff 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderThreadedClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderThreadedClient.java
@@ -3,24 +3,25 @@ package net.minecraft.client.world.chunk.provider;
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.chunk.provider.ChunkProviderThreaded;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
 import org.jetbrains.annotations.NotNull;
 
 public class ChunkProviderThreadedClient extends ChunkProviderThreaded {
-    public ChunkProviderThreadedClient(@NotNull World world, @NotNull IChunkLoader chunkLoader, @NotNull ChunkGenerator chunkGenerator) {
+    public ChunkProviderThreadedClient(@NotNull World world, @NotNull ChunkLoader chunkLoader, @NotNull ChunkGenerator chunkGenerator) {
         super(world, chunkLoader, chunkGenerator);
     }
 
     @Override
-    protected boolean isChunkValid(@NotNull ChunkPos chunkPos) {
+    protected boolean isChunkValid(@NotNull ChunkPosc chunkPos) {
         Minecraft mc = Minecraft.getMinecraft();
         int rd = this.world.renderDistance() + 1;
         if (this.chunkOver != null) {
-            int dx = this.chunkOver.x - chunkPos.x;
-            int dz = this.chunkOver.z - chunkPos.z;
+            int dx = this.chunkOver.x - chunkPos.x();
+            int dz = this.chunkOver.z - chunkPos.z();
             if (dx <= 2 && dx >= -2 && dz <= 2 && dz >= -2) {
                 return true;
             }
@@ -30,8 +31,8 @@ public class ChunkProviderThreadedClient extends ChunkProviderThreaded {
         if (player != null) {
             int pCX = ((int) player.x >> 4);
             int pCZ = ((int) player.z >> 4);
-            int dx = pCX - chunkPos.x;
-            int dz = pCZ - chunkPos.z;
+            int dx = pCX - chunkPos.x();
+            int dz = pCZ - chunkPos.z();
             return dx <= rd && dx >= -rd && dz <= rd && dz >= -rd;
         }
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java
index 287109632..6e9f8d6f6 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java
@@ -5,12 +5,12 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.DisplayChunk;
 import net.minecraft.core.world.chunk.EmptyChunk;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
+import net.minecraft.core.world.pos.ChunkPosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ChunkProviderViewer implements IChunkProvider {
+public class ChunkProviderViewer implements ChunkProvider {
     public final @NotNull Chunk blankChunk;
     public final @NotNull Chunk displayChunk;
 
@@ -20,33 +20,33 @@ public class ChunkProviderViewer implements IChunkProvider {
     }
 
     @Override
-    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+    public boolean isChunkLoaded(@NotNull ChunkPosc chunkPos) {
         return true;
     }
 
     @Override
-    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
-        if (chunkPos.x == 0 && chunkPos.z == 0) {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
+        if (chunkPos.x() == 0 && chunkPos.z() == 0) {
             return this.displayChunk;
         }
         return this.blankChunk;
     }
 
     @Override
-    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
-        if (chunkPos.x == 0 && chunkPos.z == 0) {
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
+        if (chunkPos.x() == 0 && chunkPos.z() == 0) {
             return this.displayChunk;
         }
         return this.blankChunk;
     }
 
     @Override
-    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+    public void regenerateChunk(@NotNull ChunkPosc chunkPos) {
 
     }
 
     @Override
-    public void populate(@NotNull ChunkPos chunkPos) {
+    public void populate(@NotNull ChunkPosc chunkPos) {
 
     }
 
@@ -76,7 +76,7 @@ public class ChunkProviderViewer implements IChunkProvider {
     }
 
     @Override
-    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
+    public void setCurrentChunkOver(@NotNull ChunkPosc chunkPos) {
 
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/save/LevelStorageClientSP.java b/game/client/src/main/java/net/minecraft/client/world/save/LevelStorageClientSP.java
index 2d4ff4e49..cc7207891 100644
--- a/game/client/src/main/java/net/minecraft/client/world/save/LevelStorageClientSP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/save/LevelStorageClientSP.java
@@ -3,12 +3,13 @@ package net.minecraft.client.world.save;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.chunk.ChunkLoaderRegionAsync;
-import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorageBase;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.File;
 import java.util.List;
@@ -36,7 +37,7 @@ public class LevelStorageClientSP
     }
 
     @Override
-    public IChunkLoader getChunkLoader(Dimension dimension)
+    public @Nullable ChunkLoader getChunkLoader(@NotNull Dimension dimension)
     {
         File dimDir = saveFormat.getDimensionRootDir(worldDirName, dimension);
         dimDir.mkdirs();
diff --git a/game/core/src/main/java/net/minecraft/core/MinecraftAccessor.java b/game/core/src/main/java/net/minecraft/core/MinecraftAccessor.java
index 3cda4836e..b7235272a 100644
--- a/game/core/src/main/java/net/minecraft/core/MinecraftAccessor.java
+++ b/game/core/src/main/java/net/minecraft/core/MinecraftAccessor.java
@@ -3,8 +3,8 @@ package net.minecraft.core;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 
 import java.io.File;
 import java.util.Collection;
@@ -13,8 +13,6 @@ public interface MinecraftAccessor
 {
     File getMinecraftDir();
 
-    IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader);
-
     int getAutosaveTimer();
 
     SkinVariantList getSkinVariantList();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index 8e88945a9..bd75af502 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -56,7 +56,7 @@ public class BlockLogicBed
         }
 
         // Explode in invalid dimensions
-        if (!world.worldType.mayRespawn()) {
+        if (!world.getWorldType().mayRespawn()) {
             world.setBlockTypeNotify(tilePos, Blocks.AIR);
             if (world.getBlockType(footPos) == this.block) {
                 world.setBlockTypeNotify(footPos, Blocks.AIR);
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
index c89a1f0d9..96c2e51bc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
@@ -8,6 +8,7 @@ import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import com.mojang.nbt.tags.CompoundTag;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class TileEntitySeat
     extends TileEntity
@@ -105,7 +106,7 @@ public class TileEntitySeat
     }
 
     @Override
-    public void setPassenger(Entity entity) {
+    public void setPassenger(@Nullable Entity entity) {
         this.passenger = entity;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index afa3343fe..af2b60b1d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -24,8 +24,10 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.save.LevelStorageDummy;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -509,44 +511,46 @@ public class TileEntityTrommel extends TileEntity
         }
     }
 
-    public static void main(String[] args) {
-        Blocks.init();
-        Items.init();
-
-        new Registries();
-
-        // Load vanilla recipes
-        DataLoader.loadRecipesFromFile("/recipes/blast_furnace.json");
-        DataLoader.loadRecipesFromFile("/recipes/furnace.json");
-        DataLoader.loadRecipesFromFile("/recipes/trommel.json");
-        DataLoader.loadRecipesFromFile("/recipes/workbench.json");
-
-//        DataLoader.loadDataPacks(this);
-
-        TileEntityTrommel trommel = new TileEntityTrommel();
-        trommel.worldObj = new World();
-
-        trommel.simulateTrommelDrops(10000, Blocks.MUD.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.DIRT.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.GRAVEL.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.SAND.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.SOULSAND.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.BLOCK_CLAY.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.DIRT_SCORCHED_RICH.getDefaultStack());
-    }
-
-    public static void simulate() {
-        TileEntityTrommel trommel = new TileEntityTrommel();
-        trommel.worldObj = new World();
-
-        trommel.simulateTrommelDrops(10000, Blocks.MUD.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.DIRT.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.GRAVEL.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.SAND.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.SOULSAND.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.BLOCK_CLAY.getDefaultStack());
-        trommel.simulateTrommelDrops(10000, Blocks.DIRT_SCORCHED_RICH.getDefaultStack());
-    }
+    // Move this to client
+//    public static void main(String[] args) {
+//        Blocks.init();
+//        Items.init();
+//
+//        new Registries();
+//
+//        // Load vanilla recipes
+//        DataLoader.loadRecipesFromFile("/recipes/blast_furnace.json");
+//        DataLoader.loadRecipesFromFile("/recipes/furnace.json");
+//        DataLoader.loadRecipesFromFile("/recipes/trommel.json");
+//        DataLoader.loadRecipesFromFile("/recipes/workbench.json");
+//
+////        DataLoader.loadDataPacks(this);
+//
+//        TileEntityTrommel trommel = new TileEntityTrommel();
+//        trommel.worldObj = new World(new LevelStorageDummy(), "TrommelWorld", 0, Dimension.OVERWORLD, null);
+//
+//        trommel.simulateTrommelDrops(10000, Blocks.MUD.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.DIRT.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.GRAVEL.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.SAND.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.SOULSAND.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.BLOCK_CLAY.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.DIRT_SCORCHED_RICH.getDefaultStack());
+//    }
+//
+//    @SuppressWarnings("unused")
+//    public static void simulate() {
+//        TileEntityTrommel trommel = new TileEntityTrommel();
+//        trommel.worldObj = new World(new LevelStorageDummy(), "TrommelWorld", 0, Dimension.OVERWORLD, null);
+//
+//        trommel.simulateTrommelDrops(10000, Blocks.MUD.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.DIRT.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.GRAVEL.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.SAND.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.SOULSAND.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.BLOCK_CLAY.getDefaultStack());
+//        trommel.simulateTrommelDrops(10000, Blocks.DIRT_SCORCHED_RICH.getDefaultStack());
+//    }
 
     @Override
     public void heldTick(World world, Entity holder) {
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java
index defc46d2a..2f545381b 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java
@@ -60,7 +60,7 @@ public final class GameRuleCollection
         return out;
     }
 
-    public static GameRuleCollection readFromNBT(CompoundTag tag)
+    public static @NotNull GameRuleCollection readFromNBT(CompoundTag tag)
     {
         GameRuleCollection collection = new GameRuleCollection();
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index c72f07452..758e8f824 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -54,7 +54,7 @@ import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.weather.Weathers;
@@ -1104,7 +1104,7 @@ public abstract class Player
             if (isPlayerSleeping() || !isAlive()) {
                 return EnumSleepStatus.OTHER_PROBLEM;
             }
-            if (!this.world.worldType.mayRespawn()) {
+            if (!this.world.getWorldType().mayRespawn()) {
                 return EnumSleepStatus.NOT_POSSIBLE_HERE;
             }
             if (java.lang.Math.abs(this.x - (double) x) > 3D || java.lang.Math.abs(this.y - (double) y) > 3D || java.lang.Math.abs(this.z - (double) z) > 3D) {
@@ -1219,7 +1219,7 @@ public abstract class Player
     }
 
     public static @Nullable TilePos getValidBedSpawnCoordinates(@NotNull final World world, @NotNull final TilePos coords) {
-        final IChunkProvider chunkProvider = world.getChunkProvider();
+        final ChunkProvider chunkProvider = world.getChunkProvider();
         chunkProvider.setCurrentChunkOver(coords.x >> 4, coords.z >> 4);
         chunkProvider.prepareChunk(coords.x - 3 >> 4, coords.z - 3 >> 4);
         chunkProvider.prepareChunk(coords.x + 3 >> 4, coords.z - 3 >> 4);
